﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Windows.Forms;
using RestSharp;

/************************************************************************
 *  Please install package RestSharp Using NuGet
 ************************************************************************/
namespace SubmitSMS
{
    public partial class Form1 : Form
    {
        public string protocol = "http://";
        public string host = "restapi.marketext.com";
        public string path = "/sms/";
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string port = "80";
            string endPoint = protocol + host + path + companyid.Text;
            string token = GetAuthorizationHeader(userid.Text, password.Text, "hmac-sha-256", "POST", path + companyid.Text, host, port);

            var client = new RestClient(endPoint);
            var request = new RestRequest(Method.POST);
            request.AddHeader("Accept", "text/csv");
            request.RequestFormat = DataFormat.Json;
            request.AddHeader("Authorization", token);
            request.AddParameter("destination", to.Text);
            request.AddParameter("text", message.Text);
            request.AddParameter("senderid", senderid.Text);
            request.AddParameter("smstype", smstype.Text);
            request.AddParameter("datedelivery", datedelivery.Text);
            request.AddParameter("timedelivery", timedelivery.Text);

            IRestResponse requestResponse = client.Execute(request);

            string[] arrResponse = requestResponse.Content.ToString().Split(',');
            if (arrResponse.Length >= 2)
                response.Text = arrResponse[1].Trim();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            string endPoint = protocol + host + path + companyid.Text + "/" + userid.Text + "/" + response.Text;

            var client = new RestClient(endPoint);
            var request = new RestRequest(Method.GET);
            request.AddHeader("Accept", "text/csv");
            request.RequestFormat = DataFormat.Json;

            IRestResponse requestResponse = client.Execute(request);

            smsStatus.Text = requestResponse.Content.ToString();
        }


        public string GetAuthorizationHeader(string macKeyIdentifier, string macKey, string macAlgorithm, string method, string pathandquery, string host, string port)
        {
            // byte array representation of that string
            byte[] encodedPassword = new UTF8Encoding().GetBytes(macKey);

            // need MD5 to calculate the hash
            byte[] hashMD5 = ((HashAlgorithm)CryptoConfig.CreateFromName("MD5")).ComputeHash(encodedPassword);

            // string representation (similar to UNIX format)
            string md5macKey = BitConverter.ToString(hashMD5) 
                // without dashes
               .Replace("-", string.Empty)
               // make lowercase
               .ToLower();
            ;

            TimeSpan t = (DateTime.UtcNow - new DateTime(1970, 1, 1));
            string timestamp = ((int)t.TotalSeconds).ToString();

            string nonce = new Random().Next().ToString();

            string normalizedString = string.Format("{0}\n{1}\n{2}\n{3}\n{4}\n{5}\n\n",
                                                    timestamp,
                                                    nonce,
                                                    method,
                                                    pathandquery,
                                                    host,
                                                    port);

            HashAlgorithm hashGenerator = null;
            if (macAlgorithm == "hmac-sha-256")
            {
                hashGenerator = new HMACSHA256(Encoding.ASCII.GetBytes(md5macKey));
            }
            else if (macAlgorithm == "hmac-sha-1")
            {
                hashGenerator = new HMACSHA1(Encoding.ASCII.GetBytes(md5macKey));
            }
            else
            {
                throw new InvalidOperationException("Unsupported MAC algorithm");
            }

            string hash = System.Convert.ToBase64String(hashGenerator.ComputeHash(Encoding.ASCII.GetBytes(normalizedString)));

            StringBuilder authorizationHeader = new StringBuilder();
            authorizationHeader.AppendFormat(@"id=""{0}"",ts=""{1}"",nonce=""{2}"",mac=""{3}""",
                                             macKeyIdentifier, timestamp, nonce, hash);

            return authorizationHeader.ToString();
        }
    }
}
